/** (global) */
var APP_VERSION = "1.1 Lite";

var progress = 0,
	finalprogress = 0,
	SCALE = 1,
	DEBUG = false,
	SCROLLERREF,

/** define snowlist */
	snowlist = [],
	snowcount = 0,	
	
		
/** define backgrounds */
	backgrounds = [
		{bg:'default.jpg', bgcolor:'#ffffff', img:false},
	],
	
	backgroundstotal = 1,
	
/** define shapes */
	shapes = [
		{name:'Medium Snow Flake', file:'snow-medium.png', img: null},
		{name:'Santa Claus Hat', file:'santaclaus.png', img: null},
		{name:'Merry Christmas', file:'c1.png', img: null},
		
	],	 
	
	
/** define faces */
	faceslist = [
		{name:'Eyes', file: 'eye-', count: 1, list: []},
		{name:'Noses', file: 'nose-', count: 1, list: []},
		{name:'Mouths', file: 'mouth-', count: 1, list: []},
		{name:'Buttons', file: 'buttons-', count: 1, list: []},
		{name:'Arms', file: 'arm-', count: 2, list: []},
		{name:'Hats', file: 'hat-', count: 1, list: []},
		{name:'Scarves', file: 'scarve-', count: 1, list: []},
	],
	
	faces = [],	
	facestotal = 8,
	
	
/** define dialogs */
	currentdialog = -1,	
	dialogs = [];
	
		   

/** (initialization) */
$(document).ready(function () {
	
	// start loader
	$("#loader").show();
	
	// initialize progress
	finalprogress = snowcount + backgroundstotal + shapes.length + facestotal;
	
	/* initialize help */
	$("#help").css({width: $(window).width, height: $(window.height)}).bind('touchend', function() {
		localStorage.setItem("nofirst", "yes");
		$(this).fadeOut('fast');
	});
	
	/* Initialize Scale */
	SCALE = hasScaleBug()?1.5:1; 
	
	// initialize areas
	$("#tools").buttonize(0);
	$("#buy").buttonize(function() {
		uiBuy();
	});
	$("#options").buttonize(3);
	$("#undo").buttonize(function(){
		snowman.undo();
	});
	
	// initialize backgrounds
	for(var i=0;i<backgrounds.length;i++){
		if(backgrounds[i].bg) {
			backgrounds[i].img = new Image();
			backgrounds[i].img.onload = function(){
				// convert image to data url
				progress += 1;uiUpdateProgress()
			} 
			backgrounds[i].img.src = "backgrounds/"+backgrounds[i].bg;
		}		
	}
	
	// initialize snowlist
	for(var i=0;i<snowcount;i++) {
		snowlist[i] = {img: null, mask: null};
		snowlist[i].img = new Image();
		snowlist[i].img.onload = function(){progress += 1;uiUpdateProgress()} 
		snowlist[i].img.src = "snow/"+i+".png";
		
	}
	
	// initialize shapes
	for(var i=0;i<shapes.length;i++){
	shapes[i].img = new Image();
		shapes[i].img.onload = function(){
			// convert image to data url
			progress += 1;uiUpdateProgress()
		} 
		shapes[i].img.src = "shapes/"+shapes[i].file;
	}
	
	// initialize faces
	$.each(faceslist, function(index, face) {
		for(var i=0;i<face.count;i++){
			var x = faces.length;
			faces[x] = new Image();
			faces[x].onload = function(){progress += 1;uiUpdateProgress()} 
			faces[x].src = "faces/"+face.file+i+".png";
			faceslist[index].list.push(x);
		}
	});
	
	// progress
	uiCheckProgress();
});

/** progress */
var uiUpdateProgress = function() {
	// update progressbar
	$("#progress").css("width", (progress*390)/finalprogress)
	
}

/** progress */
var uiCheckProgress = function() {
try {
	if (progress >= finalprogress) {
		// initialize pumpkin doodle
		snowman.init();
		
		
		// build tools dialog
		uiCreateDialog(0);
		
		var tabs = $("<div></div>").addClass("tools ui-corner-top"),
			scrollerouter = $("<div></div>").css({height:'482px', overflow:'hidden'}),
			scroller = $("<div></div>").attr("id", "toolscroll");
		dialogs[0].append(tabs).append(scrollerouter.append(scroller));
		
	
		// generate tab selector
		var events = {
				'touchstart': function(e){
					e.preventDefault();
					e.stopPropagation();
					$(this).fadeTo(0, 0.5);
				},
				'touchend': function(e){
					e.preventDefault();
					e.stopPropagation();
					$(this).fadeTo(0, 1);
					dialogs[0].find(".toolarea").hide();
					dialogs[0].find("#toolarea"+$(this).attr("rel")).show();
					var m = $("#toolscroll").get(0);
					m.scroller.refresh();
				}
		};
		 
		// generate knife tab
		var tabarea = $("<div></div>").addClass("toolarea").attr("id", "toolarea"+0),
			knifes = ['Snow', 'Coal'];
		$.each(knifes, function(index, caption){
			var n = $("<div></div>").addClass("link knife").html(caption).append($("<img/>").attr("src", "resources/doodle-"+index+".png")).tap(function(){
				snowman.loadCarver('carver', index);
				uiHideDialog(0);			
			}, "hover");
			tabarea.append(n);
		});
		//tabarea.makescroll();
		scroller.append(tabarea);
		tabs.append($("<div></div>").bind(events).attr("rel", 0).html("Doodle").append($("<img/>").attr("src", "resources/doodle-tab.png")));
		
				
		
		// generate faces tab
		var tabarea = $("<div></div>").addClass("toolarea").attr("id", "toolarea"+1).hide();
		$.each(faceslist, function(index, face) {
			tabarea.append($("<div></div>").addClass("facename").html(face.name).addClass(index==0?"":"second"));
			for(var i=0;i<face.list.length;i++){
				var x = face.list[i];
				var n = $("<div></div>").addClass("face").attr("rel", x).append(faces[x]).tap(function(e){
					snowman.loadCarver('face', e.attr("rel"));
					uiHideDialog(0);
				}, "hover");	
				tabarea.append(n);
			}
		});
		
		
		//tabarea.makescroll();
		scroller.append(tabarea);		
		tabs.append($("<div></div>").bind(events).attr("rel", 1).html("Faces").append($("<img/>").attr("src", "resources/faces-tab.png")));
		
		// generate shapes tab
		var tabarea = $("<div></div>").addClass("toolarea").attr("id", "toolarea"+2).hide();
		$.each(shapes, function(index) {
			var n = $("<div></div>").addClass("link shape").html(shapes[index].name).append(shapes[index].img).tap(function(){
				snowman.loadCarver('shape',index);
				uiHideDialog(0);
			}, "hover");
			tabarea.append(n);
		});
		tabarea.find("div:last").css({'border-bottom':0});
		//tabarea.makescroll();
		scroller.append(tabarea);
		tabs.append($("<div></div>").bind(events).attr("rel", 2).html("Shapes").css("border-right", 0).append($("<img/>").attr("src", "resources/shapes-tab.png")));
		
		
		
		// build pumpkin dialog
		uiCreateDialog(1);
		$.each(snowlist, function(index, p){
			var img = $(p.img).clone().get(0), size = 80;
			img.width = (img.width * size) / img.height;
			img.height = size;
			dialogs[1].append($("<div></div>").append(img).css({
				width: size,
				height: size,
				margin: 30,
				'float': 'left'
			}).bind('touchend', function(e){
				e.preventDefault();
				snowman.loadShape(index);
				uiHideDialog(1);
				
			}));
		});
		
		
		// build background dialog
		uiCreateDialog(2);
		$.each(backgrounds, function(index, p){
			var size = 116;
			var st = $("<div></div>").css({
				border: '1px solid white',
				background: p.bgcolor,
				width: size,
				height: size,
				overflow: 'hidden',
				margin: 15,
				display: 'block',
				'float': 'left'
			}).bind('touchend', function(e){
				e.preventDefault();
				snowman.loadBackground(index);
				uiHideDialog(2);
			});
			
			if (p.bg) {
				var ni = $(p.img).clone();
				st.append($(ni).attr({
					width: size,
					height: size
				}));
			}
			dialogs[2].append(st);
		});
		dialogs[2].append($("<div></div>").addClass("clear"));
		
		
		// build options dialog
		uiCreateDialog(3);
		var items = [
			{text: 'New Snowman', func: function() {snowman.newsnowman();}},
			{text: 'Save as Image', func: function() {snowman.saveImage()}},
			{text: 'Help', func: function() {uiShowHelp();}},
			{text: 'Buy Full Version', func: function() {uiBuy();}},
			//{text: 'Reset', func: function() {localStorage.clear();snowman.clearCanvas();snowman.loadData();;alert("All settings are cleared.");}},
		];
		$.each(items, function(index, link){
			var n = $("<div></div>").addClass("link").html(link.text);
			n.bind({
				'touchstart': function(e){
					e.preventDefault();
					$(this).addClass("hover");
				}, 
				'touchend': function(e){
					e.preventDefault();
					$(this).removeClass("hover");
					if(typeof(link.func)=="function") {link.func();}
					uiHideDialog(3);
				}
			});
			dialogs[3].append(n);
		});
		
		// add copyright
		dialogs[3].append($("<div></div>").css({
			background:'url(resources/about.png) no-repeat 10px 10px',
			margin: 20,
			'padding-left': 110
		}).html("<b>Build a Snowman for Android</b><br />Version "+APP_VERSION+"<br />Copyright &copy; 2010 Lusumdy<br />All rights reserved<br /><a class='link' href='http://www.lusumdy.com' target='_blank'>http://www.lusumdy.com</a>"));
		

		
		/* register back button */
		$(document).bind("backKeyDown", function() {
		 	if(currentdialog!=-1) {
				uiHideDialog(currentdialog);
			} else {
				BackButton.exitApp();
			}
			
		 });
		 
		BackButton.override();
	
		
		
		var m = scroller.get(0);
		m.scroller = new iScroll(m, {checkDOMChanges:false});
		
		// Hide Loader
		$("#loader").hide();
	
		/* show first book */
		var n = localStorage.getItem("nofirst");
		if(n!="yes") {
			uiShowHelp();
		}
		
		$("#buttoncontinue").bind("touchend", function() {
			$("#buysplash").hide();	
		});
		
		$("#buttonbuy").bind("touchend", function() {
			$("#buysplash").hide();	
			uiBuy();
		});
		
		$("#buysplash").show();		
		
	}
	else {
		setTimeout(uiCheckProgress, 500);
	}
} catch(e) {
	alert(e);
}
}


/** help */
var uiShowHelp = function() {
	$("#help").fadeIn('fast');	
}

var uiBuy = function() {
	window.DroidGap.DownloadApp("com.lusumdy.snowman");
}



/** (buttonize) */
jQuery.fn.buttonize=function(func) {
	$(this).bind({
		'touchstart': function(e) {
			e.preventDefault();
			$(this).fadeTo(0,0.5);
		},
		'touchend': function(e){
			e.preventDefault();
			if (typeof(func) == 'function') {
				func();
			} else {
				$(".dialog").hide();
				if (currentdialog != func) {
					dialogs[func].show();
					currentdialog = func;
				} else {
					currentdialog = -1;
				}
			}
			$(this).fadeTo(0,1);
		}
	});
}

/** uiCreateDialog */
var uiCreateDialog = function(id) {
	dialogs[id] = $("<div></div>").addClass("dialog ui-corner").hide();
	$('body').append(dialogs[id]);
}

/** uiHideDialog */
var uiHideDialog = function(id) {
	dialogs[id].hide();
	currentdialog = -1;
}

/** tap button */
jQuery.fn.tap=function(f,c){
	var that = $(this).get(0);
	$(this).bind({
		'touchstart': function(e){
			e.preventDefault();
			if(c)$(this).addClass(c);
			that.tapped = 0;			
		},
		'touchmove': function(e){
			if(that.tapped==1) return;
			e.preventDefault();
			// check if we leave the area of the control
			var ev = e.originalEvent,
				t = ev.changedTouches[0],
				o = $(this).offset(),
				x = t.pageX, y = t.pageY,
				cx = o.left, cy = o.top,
				cw = cx + $(this).width(), ch = cy + $(this).height();
				v = (x<cx)||(y<cy)||(x>cw)||(y>ch);
			if (v) {
				if(c)$(this).removeClass(c);
				that.tapped = 1;
			} else {
				e.stopPropagation();
			}
		},
		'touchend': function(e){
			e.preventDefault();
			if(c)$(this).removeClass(c);
			if (that.tapped == 0) {
				e.stopPropagation();
				if (typeof(f) == 'function') {
					f($(this));
				}
			} 
		}
	}); 
	return $(this);
}




var hasScaleBug = function() {var iw = 1; var ih = 1; var img = document.createElement("canvas"); img.width = iw; img.height = ih; var ictx = img.getContext("2d"); ictx.fillStyle = "#ffffff"; ictx.fillRect(0, 0, iw, ih); var bw = 100; var bh = 100; var buffer = document.createElement("canvas");buffer.width = bw; buffer.height = bh;var bctx = buffer.getContext("2d"); bctx.clearRect(0, 0, bw, bh); bctx.drawImage(img, bw/2, bh/2); var imageData = bctx.getImageData(0, 0, bw, bh); var sample = imageData.data[bw/2*bw*4+bh/2*4]; return (sample == 0);} 



